# coding=utf-8
# *** WARNING: this file was generated by the Pulumi Terraform Bridge (tfgen) Tool. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import json
import warnings
import pulumi
import pulumi.runtime
from typing import Union
from .. import utilities, tables

class GetForwardEntriesResult:
    """
    A collection of values returned by getForwardEntries.
    """
    def __init__(__self__, entries=None, external_ip=None, forward_table_id=None, ids=None, internal_ip=None, name_regex=None, names=None, output_file=None, id=None):
        if entries and not isinstance(entries, list):
            raise TypeError("Expected argument 'entries' to be a list")
        __self__.entries = entries
        """
        A list of Forward Entries. Each element contains the following attributes:
        """
        if external_ip and not isinstance(external_ip, str):
            raise TypeError("Expected argument 'external_ip' to be a str")
        __self__.external_ip = external_ip
        """
        The public IP address.
        """
        if forward_table_id and not isinstance(forward_table_id, str):
            raise TypeError("Expected argument 'forward_table_id' to be a str")
        __self__.forward_table_id = forward_table_id
        if ids and not isinstance(ids, list):
            raise TypeError("Expected argument 'ids' to be a list")
        __self__.ids = ids
        """
        A list of Forward Entries IDs.
        """
        if internal_ip and not isinstance(internal_ip, str):
            raise TypeError("Expected argument 'internal_ip' to be a str")
        __self__.internal_ip = internal_ip
        """
        The private IP address.
        """
        if name_regex and not isinstance(name_regex, str):
            raise TypeError("Expected argument 'name_regex' to be a str")
        __self__.name_regex = name_regex
        if names and not isinstance(names, list):
            raise TypeError("Expected argument 'names' to be a list")
        __self__.names = names
        """
        A list of Forward Entries names.
        """
        if output_file and not isinstance(output_file, str):
            raise TypeError("Expected argument 'output_file' to be a str")
        __self__.output_file = output_file
        if id and not isinstance(id, str):
            raise TypeError("Expected argument 'id' to be a str")
        __self__.id = id
        """
        id is the provider-assigned unique ID for this managed resource.
        """
class AwaitableGetForwardEntriesResult(GetForwardEntriesResult):
    # pylint: disable=using-constant-test
    def __await__(self):
        if False:
            yield self
        return GetForwardEntriesResult(
            entries=self.entries,
            external_ip=self.external_ip,
            forward_table_id=self.forward_table_id,
            ids=self.ids,
            internal_ip=self.internal_ip,
            name_regex=self.name_regex,
            names=self.names,
            output_file=self.output_file,
            id=self.id)

def get_forward_entries(external_ip=None,forward_table_id=None,ids=None,internal_ip=None,name_regex=None,names=None,output_file=None,opts=None):
    """
    This data source provides a list of Forward Entries owned by an Alibaba Cloud account.
    
    > **NOTE:** Available in 1.37.0+.
    
    :param str external_ip: The public IP address.
    :param str forward_table_id: The ID of the Forward table.
    :param list ids: A list of Forward Entries IDs.
    :param str internal_ip: The private IP address.
    :param str name_regex: A regex string to filter results by forward entry name.

    > This content is derived from https://github.com/terraform-providers/terraform-provider-alicloud/blob/master/website/docs/d/forward_entries.html.markdown.
    """
    __args__ = dict()

    __args__['externalIp'] = external_ip
    __args__['forwardTableId'] = forward_table_id
    __args__['ids'] = ids
    __args__['internalIp'] = internal_ip
    __args__['nameRegex'] = name_regex
    __args__['names'] = names
    __args__['outputFile'] = output_file
    if opts is None:
        opts = pulumi.InvokeOptions()
    if opts.version is None:
        opts.version = utilities.get_version()
    __ret__ = pulumi.runtime.invoke('alicloud:vpc/getForwardEntries:getForwardEntries', __args__, opts=opts).value

    return AwaitableGetForwardEntriesResult(
        entries=__ret__.get('entries'),
        external_ip=__ret__.get('externalIp'),
        forward_table_id=__ret__.get('forwardTableId'),
        ids=__ret__.get('ids'),
        internal_ip=__ret__.get('internalIp'),
        name_regex=__ret__.get('nameRegex'),
        names=__ret__.get('names'),
        output_file=__ret__.get('outputFile'),
        id=__ret__.get('id'))
