# coding=utf-8
# *** WARNING: this file was generated by the Pulumi Terraform Bridge (tfgen) Tool. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import json
import warnings
import pulumi
import pulumi.runtime
from typing import Union
from .. import utilities, tables

class SslVpnClientCert(pulumi.CustomResource):
    ca_cert: pulumi.Output[str]
    client_cert: pulumi.Output[str]
    client_config: pulumi.Output[str]
    client_key: pulumi.Output[str]
    name: pulumi.Output[str]
    ssl_vpn_server_id: pulumi.Output[str]
    status: pulumi.Output[str]
    def __init__(__self__, resource_name, opts=None, name=None, ssl_vpn_server_id=None, __props__=None, __name__=None, __opts__=None):
        """
        Create a SslVpnClientCert resource with the given unique name, props, and options.
        
        :param str resource_name: The name of the resource.
        :param pulumi.ResourceOptions opts: Options for the resource.

        > This content is derived from https://github.com/terraform-providers/terraform-provider-alicloud/blob/master/website/docs/r/ssl_vpn_client_cert.html.markdown.
        """
        if __name__ is not None:
            warnings.warn("explicit use of __name__ is deprecated", DeprecationWarning)
            resource_name = __name__
        if __opts__ is not None:
            warnings.warn("explicit use of __opts__ is deprecated, use 'opts' instead", DeprecationWarning)
            opts = __opts__
        if opts is None:
            opts = pulumi.ResourceOptions()
        if not isinstance(opts, pulumi.ResourceOptions):
            raise TypeError('Expected resource options to be a ResourceOptions instance')
        if opts.version is None:
            opts.version = utilities.get_version()
        if opts.id is None:
            if __props__ is not None:
                raise TypeError('__props__ is only valid when passed in combination with a valid opts.id to get an existing resource')
            __props__ = dict()

            __props__['name'] = name
            if ssl_vpn_server_id is None:
                raise TypeError("Missing required property 'ssl_vpn_server_id'")
            __props__['ssl_vpn_server_id'] = ssl_vpn_server_id
            __props__['ca_cert'] = None
            __props__['client_cert'] = None
            __props__['client_config'] = None
            __props__['client_key'] = None
            __props__['status'] = None
        super(SslVpnClientCert, __self__).__init__(
            'alicloud:vpn/sslVpnClientCert:SslVpnClientCert',
            resource_name,
            __props__,
            opts)

    @staticmethod
    def get(resource_name, id, opts=None, ca_cert=None, client_cert=None, client_config=None, client_key=None, name=None, ssl_vpn_server_id=None, status=None):
        """
        Get an existing SslVpnClientCert resource's state with the given name, id, and optional extra
        properties used to qualify the lookup.
        
        :param str resource_name: The unique name of the resulting resource.
        :param str id: The unique provider ID of the resource to lookup.
        :param pulumi.ResourceOptions opts: Options for the resource.

        > This content is derived from https://github.com/terraform-providers/terraform-provider-alicloud/blob/master/website/docs/r/ssl_vpn_client_cert.html.markdown.
        """
        opts = pulumi.ResourceOptions.merge(opts, pulumi.ResourceOptions(id=id))

        __props__ = dict()
        __props__["ca_cert"] = ca_cert
        __props__["client_cert"] = client_cert
        __props__["client_config"] = client_config
        __props__["client_key"] = client_key
        __props__["name"] = name
        __props__["ssl_vpn_server_id"] = ssl_vpn_server_id
        __props__["status"] = status
        return SslVpnClientCert(resource_name, opts=opts, __props__=__props__)
    def translate_output_property(self, prop):
        return tables._CAMEL_TO_SNAKE_CASE_TABLE.get(prop) or prop

    def translate_input_property(self, prop):
        return tables._SNAKE_TO_CAMEL_CASE_TABLE.get(prop) or prop

